vexalarm = {}
vexalarm.AceConfigDialog = LibStub("AceConfigDialog-3.0", true)
vexalarm.AceConfig = LibStub("AceConfig-3.0", true)
vexalarm.AceConsole= LibStub("AceConsole-3.0", true)
vexalarm.LSM = LibStub("LibSharedMedia-3.0", true)
vexalarm.LSMWidgets = LibStub("AceGUI-3.0-SharedMediaWidgets", true)

vexalarm.infight = false

vexalarm.frames = {}
vexalarm.tagWindow = false
vexalarm.testmode = false
vexalarm.testmode_recolor = false
vexalarm.wrongspells = {}

vexalarm.last_spell_id = {}
vexalarm.last_spell_timestamp = {}
vexalarm.last_spell_event = {}
vexalarm.last_spell_caster = {}
vexalarm.last_spell_id_RW = ""
vexalarm.last_spell_timestamp_RW = 0
vexalarm.last_spell_event_RW = ""
vexalarm.last_spell_caster_RW = ""
vexalarm.proclaims = {}
vexalarm.proclaimPlaces = {}
vexalarm.totemsPlaced = {}
vexalarm.totemsPlaced_RW = {}

vexalarm.incomeMsgs = {}
vexalarm.incomeSpellProfiles = {}
vexalarm.sentMsgs = {}
vexalarm.SendSuccess = false

function vexalarm_OnEvent(self, event, ...)
	if event == "PLAYER_LOGIN" then
		vexalarm_initialize()
	elseif event == "PLAYER_REGEN_DISABLED" then
		vexalarm.infight = true
		vexalarm_Proclaims_checkShow()
	elseif event == "PLAYER_REGEN_ENABLED" then
		vexalarm.infight = false
		vexalarm_Proclaims_checkShow()
	elseif event == "CHAT_MSG_ADDON" then
		if select(4, ...) ~= select(1, UnitName("player")) then
			local prefix = select(1, ...)
			local msg = select(2, ...)
			local sender = select(4, ...)
			if prefix == "VEXALARM_SP" then
				vexalarm_Msgs_recSP(msg, sender)
			elseif prefix == "VEXALARM_SP_RE" then
				vexalarm_Msgs_recSP_RE(msg, sender)
			end
		end
	elseif event == "COMBAT_LOG_EVENT_UNFILTERED" then
		if vexalarm_data["enable"] then
			local eventchar  = select(2, ...)
			local legal_eventchars = {
				"SPELL_AURA_APPLIED",
				"SPELL_CAST_SUCCESS",
				"SPELL_AURA_REMOVED",
				"SPELL_SUMMON",
				"SPELL_RESURRECT",
				}
				
			local accept_event = false
			for i,v in ipairs(legal_eventchars) do
				if eventchar == v then
					accept_event = true
				end
			end
			
			if accept_event then
				local caster = select(5, ...)
				local spellid = select(12, ...)
				local spellname = select(13, ...)
				local target = select(9, ...)
				local status = eventchar == "SPELL_AURA_APPLIED" or eventchar == "SPELL_CAST_SUCCESS" or eventchar == "SPELL_SUMMON" or eventchar == "SPELL_RESURRECT"
								
				vexalarm_Proclaims_handler(spellname, spellid, caster, target, status, eventchar)
				vexalarm_RW_handler(spellname, spellid, caster, target, status, eventchar)
			elseif eventchar == "UNIT_DESTROYED" then
				vexalarm_Totem_cleanRegistry()
				vexalarm_Totem_inactiveHandler(select(9, ...))
			end
		end
	end
end